{
module Parser (parse, RegExp(..) ) where

import RegExpData
            
}

%name parse
%tokentype { Token }
%token
    '+' { '+' }
    '.' { '.' }
    '*' { '*' }
    '(' { '(' }
    ')' { ')' }
    '^' { '^' }
    '0' { '0' }
    'a' { 'a' }
    'b' { 'b' }
    'c' { 'c' }
    'd' { 'd' }
    'e' { 'e' }
    'f' { 'f' }
    'g' { 'g' }
    'h' { 'h' }
    'i' { 'i' }
    'j' { 'j' }
    'k' { 'k' }
    'l' { 'l' }
    'm' { 'm' }
    'n' { 'n' }
    'o' { 'o' }
    'p' { 'p' }
    'q' { 'q' }
    'r' { 'r' }
    's' { 's' }
    't' { 't' }
    'u' { 'u' }
    'v' { 'v' }
    'w' { 'w' }
    'x' { 'x' }
    'y' { 'y' }
    'z' { 'z' }

%%

RegExp : Dot  { $1 }
       | Atom { $1 }
       | Plus { $1 }

Plus : PlusAtom '+' PlusPart { Union ($1:$3) }

PlusAtom : Atom { $1 }
         | Dot  { $1 }

PlusPart : Atom { [$1] }
         | Dot  { [$1] }
         | Plus { getUnion $1 }

Dot  : Atom '.' DotPart { Concat ($1:$3) }
     | Atom     DotPart { Concat ($1:$2) }

DotPart : Atom { [$1] }
        | Dot  { getConcat $1 }

Atom : '(' RegExp ')' { $2 }
     | '0'            { Omega }
     | '^'            { Kleene Omega }
     | Letter         { Terminal $1 }
     | Atom '*'       { Kleene $1 }

Letter : 'a' { 'a' }
       | 'b' { 'b' }
       | 'c' { 'c' }
       | 'd' { 'd' }
       | 'e' { 'e' }
       | 'f' { 'f' }
       | 'g' { 'g' }
       | 'h' { 'h' }
       | 'i' { 'i' }
       | 'j' { 'j' }
       | 'k' { 'k' }
       | 'l' { 'l' }
       | 'm' { 'm' }
       | 'n' { 'n' }
       | 'o' { 'o' }
       | 'p' { 'p' }
       | 'q' { 'q' }
       | 'r' { 'r' }
       | 's' { 's' }
       | 't' { 't' }
       | 'u' { 'u' }
       | 'v' { 'v' }
       | 'w' { 'w' }
       | 'x' { 'x' }
       | 'y' { 'y' }
       | 'z' { 'z' }
     
{
happyError :: [Token] -> a
happyError _ = error "Parse error"


type Token = Char
}
